=== debian/changelog ===
mathgl (2.5-2) unstable; urgency=medium

  * Team upload
  * Upload to unstable

 -- Rafael Laboissière <rafael@debian.org>  Fri, 24 Dec 2021 13:17:49 -0300

mathgl (2.5-1) experimental; urgency=medium

  * Team upload

  * Upload to experimental, due to the bump in the SOVERSION of the
    libraries and the name of the packages.

  * New upstream version 2.5
  * d/p/python3.patch: Drop patch (applied upstream)
  * d/control:
    + Adjust package names for new upstream SOVERSION
    + Tighten dependency on libmgl-data to the current source:Version
    + Bump Standards-Version to 4.6.0 (no changes needed)
    + Bump to debhelper compatibility level 13
    + Build-depend on desktop-file-utils
  * Adjust the names of the d/lib*.install files for new upstream SOVERSION
  * New scheme for enabling cmake modules
    + d/p/CMakeLists.patch: Drop patch
    + d/rules: Activate the modules through -D options to dh_auto_configure
  * New upstream installation path for Python files
    + d/python3-mathgl.install: Adjust for new upstream layout
    + d/not-installed: Ignore the .pyc file
  * d/mathgl.install: Include mgllab.desktop
  * d/udav.install: Fix location of udav.desktop
  * d/u/metadata: New file
  * d/rules: Drop dependency on libmgl-data for secondary libraries.
    All libmgl-*<soversion> libraries depend on the main library
    libmgl<soversion>, which depends on libmgl-data.
  * d/libmgl-data.install: Install the gettext (*.mo) files
  * d/libmgl-dev.install: Install the *.cmake files
  * d/libmgl-dev.examples: Install the examples

 -- Rafael Laboissière <rafael@debian.org>  Sat, 18 Dec 2021 05:01:32 -0300

mathgl (2.4.4-7) unstable; urgency=medium

  * Upload to unstable

 -- Rafael Laboissière <rafael@debian.org>  Wed, 09 Dec 2020 16:03:25 -0300

mathgl (2.4.4-7~exp) experimental; urgency=medium

  * Team upload
  * Disable building of the SWIG binding for Octave (Closes: #976381)
  * Bump Standards-Version to 4.5.1 (no changes needed)
  * Add Rules-Requires-Root: no
  * Fix wildcard matches in copyright file
  * Add DEP3 headers to the Debian patches
  * Bump version of watch file to 4

 -- Rafael Laboissière <rafael@debian.org>  Sun, 06 Dec 2020 05:37:53 -0300
